//
// Created by Иван_Архипов on 24.11.2017.
//

#include "UnknownSubfile.h"
#include "../../include/BinaryData.h"
#include "../../include/DatFile.h"
#include "../../include/DatException.h"
#include "../../include/SubfileData.h"

namespace LOTRO_DAT {
    UnknownSubfile::UnknownSubfile() = default;

    UnknownSubfile::UnknownSubfile(DatFile *dat, long long dictionary_offset, long long fragments_count, long long unknown1,
                                   long long file_id, long long file_offset, long long file_size, long long timestamp,
                                   long long version, long long block_size)
            : Subfile(dat, dictionary_offset, fragments_count, unknown1, file_id, file_offset, file_size, timestamp,
                      version, block_size) {
    }

    FILE_TYPE UnknownSubfile::FileType() const {
        return UNKNOWN;
    }

    std::string UnknownSubfile::Extension() const {
        return std::string(".unknown");
    }

    SubfileData UnknownSubfile::PrepareForExport(const BinaryData &file_data) {
        SubfileData result;
        result.binary_data = file_data;
        result.options["fid"] = file_id();
        result.options["ext"] = Extension();
        return result;
    }

    BinaryData UnknownSubfile::MakeForImport(const BinaryData &old_data, const SubfileData &data) {
        if (!data.options["ext"] || data.options["ext"].as<std::string>() != Extension() ||
            !data.options["fid"] || data.options["fid"].as<long long>() != file_id()) {
            throw DatException("Bad DdsSubfile::MakeForImport() - invalid options data!", IMPORT_EXCEPTION);
        }
        return old_data.CutData(0, 16) + data.binary_data;
    }
};